#pragma once

extern char logBuffer[4096];
extern char lineBuff[sizeof(logBuffer) + 400];

//#define SERIAL_DEBUG

#ifdef WIFI && !SERIAL_DEBUG 

#define LOGF(F,...) \
  do  { \
    int len = sprintf(lineBuff, (F), __VA_ARGS__ ); \
	memmove(logBuffer + len, logBuffer, sizeof(logBuffer) - len); \
    memcpy(logBuffer, lineBuff, len); \
    logBuffer[sizeof(logBuffer) -1] = 0; \
  } while (false)

#define LOG(F) \
  do  { \
    int len = strlen(F); \
    memmove(logBuffer + len, logBuffer, sizeof(logBuffer) - len); \
    memcpy(logBuffer, F, len); \
    logBuffer[sizeof(logBuffer) -1] = 0; \
  } while (false)

#else
#define LOGF(F,...) \
  do  { \
    int len = sprintf(lineBuff, (F), __VA_ARGS__ ); \
	Serial.write(lineBuff, len); \
  } while (false)

#define LOG(F) \
  do  { \
	Serial.print(F); \
  }	while (false)

#endif